diff --git a/as.h b/as.h
new file mode 100644
index 0000000..40b2ebd
--- /dev/null
+++ b/as.h
@@ -0,0 +1,210 @@
+/*
+ * Copyright 2004-2006 Timo Hirvonen
+ *
+ * as.[ch] by Frank Terbeck <ft@bewatermyfriend.de>
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
+ * 02111-1307, USA.
+ */
+
+#ifndef x__AS_H
+#define x__AS_H
+
+/*
+ * audioscrobbler code for cmus {{{
+ *   (read: get cmus properly working with http://last.fm/
+ *
+ * When are songs submitted?
+ *  + Each song should be posted to the server when it is 50%
+ *    or 240 seconds complete, whichever comes first.
+ *
+ *  + If a user seeks (i.e. manually changes position) within a song
+ *    before the song is due to be submitted, do not submit that song.
+ *
+ *  + Songs with a duration of less than 30 seconds should not be
+ *    submitted (so, we don't do that).
+ *
+ *  + Do not try to guess info from the filename - if there are no
+ *    tags, don't submit the file (okeydoke, herman).
+ *
+ *  + If a MusicBrainz ID is present in the file (as defined here),
+ *    then you should send it (whatever that is...[1]).
+ *
+ *  + If a user is playing a stream instead of a regular file, do
+ *    not submit that stream/song.
+ *
+ *********************************************************************
+ *
+ * [1] About musicbrainz.org:
+ *      I don't know what that is, nor do I care. Feel free to
+ *      implement support for it, if you need it desperately.
+ *}}}
+ */
+
+#include "list.h"
+#include "options.h"
+#include "strlib.h"
+#include "track_info.h"
+
+/* #defines */
+
+/* We are currently testing things, so "tst" is okay. */
+#define AS_UASTRING        "User-Agent: AudioScrobbler/1.1 cmus-scrobbler code v0.01\r\n"
+#define AS_UASTRINGLEN       58
+#define AS_CLIENT_ID       "tst"
+#define AS_PROTO           "1.1"
+
+#define AS_HOSTNAME        "post.audioscrobbler.com"
+#define AS_HOSTPORT        "80"
+#define AS_HS_URI          "/?hs=true"
+
+#define AS_BUFSIZE         4096
+
+/* AS_QUEUE_MAX must of an element of [1..10] */
+#define AS_QUEUE_MAX         10
+
+/*
+ * AS_FORCE_SUBMIT:
+ * if our queue holds this many entries, force submission,
+ * no matter what the last INTERVAL response said.
+ */
+#define AS_FORCE_SUBMIT       8
+
+/* AS_DO_SUBMIT marks a track for submission */
+#define AS_SC_DO_SUBMIT       1
+
+/* AS_DONT_SUBMIT is used if seek was used at the beginning of a track */
+#define AS_SC_DONT_SUBMIT     2
+
+/* AS_SC_SUBMITTED marks tracks, that where included in a submission msg */
+#define AS_SC_SUBMITTED       4
+
+/* AS_SC_ALL is the same as ORing together all other AS_SC_* macros */
+#define AS_SC_ALL            15
+
+/* The minimum length of a track to be considered for submission */
+#define AS_TRACK_MINLEN      30
+
+/* A track must have run 50% of its time or AS_TRACK_MINSECS seconds */
+#define AS_TRACK_MINSECS    240
+
+/* AS_SLEEP* sets up the resolution of as_loop() */
+#define AS_SLEEPSEC           5
+#define AS_SLEEPNANO          0
+
+/*
+ * for temporary static strings, that need to be long enough
+ * to hold an url_encoded time string (25+1); this is used for
+ * strings that are converted integers.
+ */
+#define AS_MAXTMPLEN         30
+
+/* data types */
+enum as_actions {
+	AS_AUTONEXT=1,
+	AS_SEEK,
+	AS_NEXT,
+	AS_PREV,
+	AS_STOP,
+	AS_TREE_ENTER,
+	AS_SORTED_ENTER,
+	AS_PL_ENTER
+};
+
+struct as_queue {
+	struct list_head node;
+	string_t s;
+	unsigned int len;
+	unsigned short int sc;           /* AS_SC_* */
+	unsigned short int needrenumber; /* we must renumber 'string_t s'  */
+	unsigned short int num;          /* number of the current entry    */
+};
+
+struct as_hsinfo {
+	unsigned int need_handshake;
+	unsigned int failed;
+	time_t       interval;
+	string_t challenge;
+	string_t host;
+	string_t path;
+	char     port[AS_MAXTMPLEN+1];   /* yes, port as a string. tcp_connect expects its port as char[] */
+};
+
+struct as_authinfo {
+	char user[OPTION_MAX_SIZE];
+	char pass[OPTION_MAX_SIZE];
+};
+
+/* function prototypes */
+void as_hook(enum as_actions action);
+void *as_loop(void *arg);
+void as_exit(void);
+void as_init(void);
+
+/* macros */
+#define as_addtag(dest, src, tag)			\
+	str_readya(&(dest), 6);				\
+	str_ncat(  &(dest), tag, 3);			\
+	str_ncat(  &(dest), as_numbers[ptr->num], 1);	\
+	str_ncat(  &(dest), "]=", 2);			\
+	str_readya(&(dest), src->len);			\
+	str_cat(   &(dest), src)
+
+#define as_addntag(dest, src, len, tag)			\
+	str_readya(&(dest), 6);				\
+	str_ncat(  &(dest), tag, 3);			\
+	str_ncat(  &(dest), as_numbers[ptr->num], 1);	\
+	str_ncat(  &(dest), "]=", 2);			\
+	str_readya(&(dest), len);			\
+	str_ncat(  &(dest), src, len)
+
+#define mustquote(c) \
+	c == ' '  || \
+	c == '!'  || \
+	c == '\"' || \
+	c == '#'  || \
+	c == '%'  || \
+	c == '&'  || \
+	c == '\'' || \
+	c == '('  || \
+	c == ')'  || \
+	c == '*'  || \
+	c == '-'  || \
+	c == '/'  || \
+	c == ':'  || \
+	c == ';'  || \
+	c == '<'  || \
+	c == '='  || \
+	c == '>'  || \
+	c == '?'  || \
+	c == '@'  || \
+	c == '['  || \
+	c == '\\' || \
+	c == ']'  || \
+	c == '^'  || \
+	c == '`'  || \
+	c == '{'  || \
+	c == '|'  || \
+	c == '}'  || \
+	c == '~'
+
+#define as_lock()   cmus_mutex_lock(&as_mutex)
+#define as_unlock() cmus_mutex_unlock(&as_mutex)
+
+/* exported variables */
+extern int as_enable;
+extern struct as_authinfo as_authinfo;
+
+#endif /* x__AS_H */
diff --git a/cmus.c b/cmus.c
index 50aafaf..55f1c53 100644
--- a/cmus.c
+++ b/cmus.c
@@ -14,6 +14,7 @@
 #include "xmalloc.h"
 #include "xstrjoin.h"
 #include "debug.h"
+#include "as.h"
 #include "load_dir.h"
 
 #include <sys/types.h>
diff --git a/command_mode.c b/command_mode.c
index 9626d24..4c94da0 100644
--- a/command_mode.c
+++ b/command_mode.c
@@ -45,6 +45,7 @@
 #include "list.h"
 #include "debug.h"
 #include "load_dir.h"
+#include "as.h"
 #include "config/datadir.h"
 #include "help.h"
 
@@ -454,6 +455,8 @@ static void cmd_seek(char *arg)
 	int relative = 0;
 	int seek = 0, sign = 1, count;
 
+	as_hook(AS_SEEK);
+
 	switch (*arg) {
 	case '-':
 		sign = -1;
@@ -1191,6 +1194,7 @@ static void cmd_view(char *arg)
 
 static void cmd_p_next(char *arg)
 {
+	as_hook(AS_NEXT);
 	cmus_next();
 }
 
@@ -1210,11 +1214,13 @@ static void cmd_p_play(char *arg)
 
 static void cmd_p_prev(char *arg)
 {
+	as_hook(AS_PREV);
 	cmus_prev();
 }
 
 static void cmd_p_stop(char *arg)
 {
+	as_hook(AS_STOP);
 	player_stop();
 }
 
@@ -1736,7 +1742,6 @@ static void expand_key_context(const char *str, const char *force)
 	snprintf(expbuf, sizeof(expbuf), "%s%s", force, str);
 	tabexp.head = xstrdup(expbuf);
 	tabexp.tails = tails;
-	tabexp.nr_tails = pos;
 }
 
 static int get_context(const char *str, int len)
@@ -1832,7 +1837,6 @@ static void expand_bind_args(const char *str)
 		ptr_array_plug(&array);
 		tabexp.head = xstrdup(expbuf);
 		tabexp.tails = array.ptrs;
-		tabexp.nr_tails = array.count;
 		return;
 	}
 
@@ -1926,7 +1930,6 @@ static void expand_unbind_args(const char *str)
 	ptr_array_plug(&array);
 	tabexp.head = xstrdup(expbuf);
 	tabexp.tails = array.ptrs;
-	tabexp.nr_tails = array.count;
 }
 
 static void expand_factivate(const char *str)
@@ -1957,7 +1960,6 @@ static void expand_factivate(const char *str)
 	ptr_array_plug(&array);
 	tabexp.head = xstrdup(str);
 	tabexp.tails = array.ptrs;
-	tabexp.nr_tails = array.count;
 }
 
 static void expand_options(const char *str)
@@ -1985,7 +1987,6 @@ static void expand_options(const char *str)
 
 				tabexp.head = xstrdup(str);
 				tabexp.tails = tails;
-				tabexp.nr_tails = 1;
 				free(var);
 				return;
 			}
@@ -2013,7 +2014,6 @@ static void expand_options(const char *str)
 			tails[pos] = NULL;
 			tabexp.head = xstrdup(str);
 			tabexp.tails = tails;
-			tabexp.nr_tails = pos;
 		} else {
 			free(tails);
 		}
@@ -2039,7 +2039,6 @@ static void expand_toptions(const char *str)
 		tails[pos] = NULL;
 		tabexp.head = xstrdup(str);
 		tabexp.tails = tails;
-		tabexp.nr_tails = pos;
 	} else {
 		free(tails);
 	}
@@ -2086,7 +2085,6 @@ static void expand_colorscheme(const char *str)
 		ptr_array_plug(&array);
 		tabexp.head = xstrdup(str);
 		tabexp.tails = array.ptrs;
-		tabexp.nr_tails = array.count;
 	}
 }
 
@@ -2174,7 +2172,6 @@ static void expand_commands(const char *str)
 		tails[pos] = NULL;
 		tabexp.head = xstrdup(str);
 		tabexp.tails = tails;
-		tabexp.nr_tails = pos;
 	} else {
 		free(tails);
 	}
diff --git a/comment.c b/comment.c
index 0cf2cb6..c36c705 100644
--- a/comment.c
+++ b/comment.c
@@ -75,6 +75,43 @@ int comments_get_int(const struct keyval *comments, const char *key)
 	return ival;
 }
 
+/* Return date as an integer in the form YYYYMMDD, for sorting purposes.
+ * This function is not year 10000 compliant. */
+int comments_get_date(const struct keyval *comments, const char *key)
+{
+	const char *val;
+	char *endptr;
+	int year, month, day;
+	long int ival;
+
+	val = comments_get_val(comments, key);
+	if (val == NULL)
+		return -1;
+
+	year = strtol(val, &endptr, 10);
+	/* Looking for a four-digit number */
+	if (year < 1000 || year > 9999)
+		return -1;
+	ival = year * 10000;
+
+	if (*endptr == '-' || *endptr == ' ' || *endptr == '/') {
+		month = strtol(endptr+1, &endptr, 10);
+		if (month < 1 || month > 12)
+			return ival;
+		ival += month * 100;
+	}
+
+	if (*endptr == '-' || *endptr == ' ' || *endptr == '/') {
+		day = strtol(endptr+1, &endptr, 10);
+		if (day < 1 || day > 31)
+			return ival;
+		ival += day;
+	}
+
+
+	return ival;
+}
+
 static const char *interesting[] = {
 	"artist", "album", "title", "tracknumber", "discnumber", "genre",
 	"date", "compilation", "albumartist",  NULL
diff --git a/comment.h b/comment.h
index 0e5b991..193fc9e 100644
--- a/comment.h
+++ b/comment.h
@@ -31,6 +31,7 @@ extern void comments_free(struct keyval *comments);
 /* case insensitive key */
 extern const char *comments_get_val(const struct keyval *comments, const char *key);
 extern int comments_get_int(const struct keyval *comments, const char *key);
+extern int comments_get_date(const struct keyval *comments, const char *key);
 
 int is_interesting_key(const char *key);
 void fix_track_or_disc(char *str);
diff --git a/editable.c b/editable.c
index ae0dce0..3394b87 100644
--- a/editable.c
+++ b/editable.c
@@ -105,7 +105,10 @@ static const char **sort_keys;
 
 static int list_cmp(const struct list_head *a_head, const struct list_head *b_head)
 {
-	return simple_track_cmp(a_head, b_head, sort_keys);
+	const struct simple_track *a = to_simple_track(a_head);
+	const struct simple_track *b = to_simple_track(b_head);
+
+	return track_info_cmp(a->info, b->info, sort_keys);
 }
 
 void editable_sort(struct editable *e)
diff --git a/flac.c b/flac.c
index 10b4762..a95a497 100644
--- a/flac.c
+++ b/flac.c
@@ -338,6 +338,10 @@ static void metadata_cb(const Dec *dec, const FLAC__StreamMetadata *metadata, vo
 							&key, &val))
 					continue;
 
+				if (!strcasecmp(key, "album_artist")) {
+					free(key);
+					key = xstrdup("albumartist");
+				}
 				if (!is_interesting_key(key)) {
 					free(key);
 					free(val);
diff --git a/lib.c b/lib.c
index 4206b46..6204585 100644
--- a/lib.c
+++ b/lib.c
@@ -4,9 +4,11 @@
 
 #include "lib.h"
 #include "editable.h"
+#include "track_info.h"
 #include "options.h"
 #include "xmalloc.h"
 #include "debug.h"
+#include "as.h"
 
 #include <pthread.h>
 #include <string.h>
@@ -357,6 +359,7 @@ struct track_info *sorted_set_selected(void)
 	if (list_empty(&lib_editable.head))
 		return NULL;
 
+	as_hook(AS_SORTED_ENTER);
 	window_get_sel(lib_editable.win, &sel);
 	return lib_set_track(iter_to_sorted_track(&sel));
 }
@@ -462,12 +465,12 @@ void sorted_sel_current(void)
 	}
 }
 
-static int ti_filename_cmp(const void *a, const void *b)
+static int ti_cmp(const void *a, const void *b)
 {
-	const struct track_info *tia = *(const struct track_info **)a;
-	const struct track_info *tib = *(const struct track_info **)b;
+	const struct track_info *ai = *(const struct track_info **)a;
+	const struct track_info *bi = *(const struct track_info **)b;
 
-	return strcmp(tia->filename, tib->filename);
+	return track_info_cmp(ai, bi, lib_editable.sort_keys);
 }
 
 int lib_for_each(int (*cb)(void *data, struct track_info *ti), void *data)
@@ -492,8 +495,8 @@ int lib_for_each(int (*cb)(void *data, struct track_info *ti), void *data)
 		}
 	}
 
-	/* sort them by filename and call cb for each */
-	qsort(tis, count, sizeof(struct track_info *), ti_filename_cmp);
+	/* sort to speed up playlist loading */
+	qsort(tis, count, sizeof(struct track_info *), ti_cmp);
 	for (i = 0; i < count; i++) {
 		rc = cb(data, tis[i]);
 		if (rc)
diff --git a/load_dir.c b/load_dir.c
index 5426fc0..6d5a0ee 100644
--- a/load_dir.c
+++ b/load_dir.c
@@ -43,6 +43,14 @@ const char *dir_read(struct directory *dir)
 	char *full = dir->path;
 	struct dirent *de;
 
+#if defined(__CYGWIN__)
+	/* Fix for cygwin "hang" bug when browsing /
+	 * Windows treats // as a network path.
+	 */
+	if (strcmp(full, "//") == 0)
+		full++;
+#endif
+
 	while ((de = readdir(d))) {
 		const char *name = de->d_name;
 		int nlen = strlen(name);
diff --git a/md5.c b/md5.c
new file mode 100644
index 0000000..5b31899
--- /dev/null
+++ b/md5.c
@@ -0,0 +1,408 @@
+/*
+ *  RFC 1321 compliant MD5 implementation
+ *
+ *  Copyright (C) 2003-2006  Christophe Devine
+ *
+ *  This library is free software; you can redistribute it and/or
+ *  modify it under the terms of the GNU Lesser General Public
+ *  License, version 2.1 as published by the Free Software Foundation.
+ *
+ *  This library is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ *  Lesser General Public License for more details.
+ *
+ *  You should have received a copy of the GNU Lesser General Public
+ *  License along with this library; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ *  MA  02110-1301  USA
+ */
+/*
+ *  The MD5 algorithm was designed by Ron Rivest in 1991.
+ *
+ *  http://www.ietf.org/rfc/rfc1321.txt
+ */
+
+#ifndef _CRT_SECURE_NO_DEPRECATE
+#define _CRT_SECURE_NO_DEPRECATE 1
+#endif
+
+#include <string.h>
+#include <stdio.h>
+
+#include "md5.h"
+
+/* 
+ * 32-bit integer manipulation macros (little endian)
+ */
+#ifndef GET_UINT32_LE
+#define GET_UINT32_LE(n,b,i)                    \
+{                                               \
+    (n) = ( (ulong) (b)[(i)    ]       )        \
+        | ( (ulong) (b)[(i) + 1] <<  8 )        \
+        | ( (ulong) (b)[(i) + 2] << 16 )        \
+        | ( (ulong) (b)[(i) + 3] << 24 );       \
+}
+#endif
+#ifndef PUT_UINT32_LE
+#define PUT_UINT32_LE(n,b,i)                    \
+{                                               \
+    (b)[(i)    ] = (uchar) ( (n)       );       \
+    (b)[(i) + 1] = (uchar) ( (n) >>  8 );       \
+    (b)[(i) + 2] = (uchar) ( (n) >> 16 );       \
+    (b)[(i) + 3] = (uchar) ( (n) >> 24 );       \
+}
+#endif
+
+/*
+ * Core MD5 functions
+ */
+void md5_starts( md5_context *ctx )
+{
+    ctx->total[0] = 0;
+    ctx->total[1] = 0;
+
+    ctx->state[0] = 0x67452301;
+    ctx->state[1] = 0xEFCDAB89;
+    ctx->state[2] = 0x98BADCFE;
+    ctx->state[3] = 0x10325476;
+}
+
+static void md5_process( md5_context *ctx, uchar data[64] )
+{
+    ulong X[16], A, B, C, D;
+
+    GET_UINT32_LE( X[0],  data,  0 );
+    GET_UINT32_LE( X[1],  data,  4 );
+    GET_UINT32_LE( X[2],  data,  8 );
+    GET_UINT32_LE( X[3],  data, 12 );
+    GET_UINT32_LE( X[4],  data, 16 );
+    GET_UINT32_LE( X[5],  data, 20 );
+    GET_UINT32_LE( X[6],  data, 24 );
+    GET_UINT32_LE( X[7],  data, 28 );
+    GET_UINT32_LE( X[8],  data, 32 );
+    GET_UINT32_LE( X[9],  data, 36 );
+    GET_UINT32_LE( X[10], data, 40 );
+    GET_UINT32_LE( X[11], data, 44 );
+    GET_UINT32_LE( X[12], data, 48 );
+    GET_UINT32_LE( X[13], data, 52 );
+    GET_UINT32_LE( X[14], data, 56 );
+    GET_UINT32_LE( X[15], data, 60 );
+
+#define S(x,n) ((x << n) | ((x & 0xFFFFFFFF) >> (32 - n)))
+
+#define P(a,b,c,d,k,s,t)                                \
+{                                                       \
+    a += F(b,c,d) + X[k] + t; a = S(a,s) + b;           \
+}
+
+    A = ctx->state[0];
+    B = ctx->state[1];
+    C = ctx->state[2];
+    D = ctx->state[3];
+
+#define F(x,y,z) (z ^ (x & (y ^ z)))
+
+    P( A, B, C, D,  0,  7, 0xD76AA478 );
+    P( D, A, B, C,  1, 12, 0xE8C7B756 );
+    P( C, D, A, B,  2, 17, 0x242070DB );
+    P( B, C, D, A,  3, 22, 0xC1BDCEEE );
+    P( A, B, C, D,  4,  7, 0xF57C0FAF );
+    P( D, A, B, C,  5, 12, 0x4787C62A );
+    P( C, D, A, B,  6, 17, 0xA8304613 );
+    P( B, C, D, A,  7, 22, 0xFD469501 );
+    P( A, B, C, D,  8,  7, 0x698098D8 );
+    P( D, A, B, C,  9, 12, 0x8B44F7AF );
+    P( C, D, A, B, 10, 17, 0xFFFF5BB1 );
+    P( B, C, D, A, 11, 22, 0x895CD7BE );
+    P( A, B, C, D, 12,  7, 0x6B901122 );
+    P( D, A, B, C, 13, 12, 0xFD987193 );
+    P( C, D, A, B, 14, 17, 0xA679438E );
+    P( B, C, D, A, 15, 22, 0x49B40821 );
+
+#undef F
+
+#define F(x,y,z) (y ^ (z & (x ^ y)))
+
+    P( A, B, C, D,  1,  5, 0xF61E2562 );
+    P( D, A, B, C,  6,  9, 0xC040B340 );
+    P( C, D, A, B, 11, 14, 0x265E5A51 );
+    P( B, C, D, A,  0, 20, 0xE9B6C7AA );
+    P( A, B, C, D,  5,  5, 0xD62F105D );
+    P( D, A, B, C, 10,  9, 0x02441453 );
+    P( C, D, A, B, 15, 14, 0xD8A1E681 );
+    P( B, C, D, A,  4, 20, 0xE7D3FBC8 );
+    P( A, B, C, D,  9,  5, 0x21E1CDE6 );
+    P( D, A, B, C, 14,  9, 0xC33707D6 );
+    P( C, D, A, B,  3, 14, 0xF4D50D87 );
+    P( B, C, D, A,  8, 20, 0x455A14ED );
+    P( A, B, C, D, 13,  5, 0xA9E3E905 );
+    P( D, A, B, C,  2,  9, 0xFCEFA3F8 );
+    P( C, D, A, B,  7, 14, 0x676F02D9 );
+    P( B, C, D, A, 12, 20, 0x8D2A4C8A );
+
+#undef F
+    
+#define F(x,y,z) (x ^ y ^ z)
+
+    P( A, B, C, D,  5,  4, 0xFFFA3942 );
+    P( D, A, B, C,  8, 11, 0x8771F681 );
+    P( C, D, A, B, 11, 16, 0x6D9D6122 );
+    P( B, C, D, A, 14, 23, 0xFDE5380C );
+    P( A, B, C, D,  1,  4, 0xA4BEEA44 );
+    P( D, A, B, C,  4, 11, 0x4BDECFA9 );
+    P( C, D, A, B,  7, 16, 0xF6BB4B60 );
+    P( B, C, D, A, 10, 23, 0xBEBFBC70 );
+    P( A, B, C, D, 13,  4, 0x289B7EC6 );
+    P( D, A, B, C,  0, 11, 0xEAA127FA );
+    P( C, D, A, B,  3, 16, 0xD4EF3085 );
+    P( B, C, D, A,  6, 23, 0x04881D05 );
+    P( A, B, C, D,  9,  4, 0xD9D4D039 );
+    P( D, A, B, C, 12, 11, 0xE6DB99E5 );
+    P( C, D, A, B, 15, 16, 0x1FA27CF8 );
+    P( B, C, D, A,  2, 23, 0xC4AC5665 );
+
+#undef F
+
+#define F(x,y,z) (y ^ (x | ~z))
+
+    P( A, B, C, D,  0,  6, 0xF4292244 );
+    P( D, A, B, C,  7, 10, 0x432AFF97 );
+    P( C, D, A, B, 14, 15, 0xAB9423A7 );
+    P( B, C, D, A,  5, 21, 0xFC93A039 );
+    P( A, B, C, D, 12,  6, 0x655B59C3 );
+    P( D, A, B, C,  3, 10, 0x8F0CCC92 );
+    P( C, D, A, B, 10, 15, 0xFFEFF47D );
+    P( B, C, D, A,  1, 21, 0x85845DD1 );
+    P( A, B, C, D,  8,  6, 0x6FA87E4F );
+    P( D, A, B, C, 15, 10, 0xFE2CE6E0 );
+    P( C, D, A, B,  6, 15, 0xA3014314 );
+    P( B, C, D, A, 13, 21, 0x4E0811A1 );
+    P( A, B, C, D,  4,  6, 0xF7537E82 );
+    P( D, A, B, C, 11, 10, 0xBD3AF235 );
+    P( C, D, A, B,  2, 15, 0x2AD7D2BB );
+    P( B, C, D, A,  9, 21, 0xEB86D391 );
+
+#undef F
+
+    ctx->state[0] += A;
+    ctx->state[1] += B;
+    ctx->state[2] += C;
+    ctx->state[3] += D;
+}
+
+void md5_update( md5_context *ctx, uchar *input, uint length )
+{
+    ulong left, fill;
+
+    if( ! length ) return;
+
+    left = ctx->total[0] & 0x3F;
+    fill = 64 - left;
+
+    ctx->total[0] += length;
+    ctx->total[0] &= 0xFFFFFFFF;
+
+    if( ctx->total[0] < length )
+        ctx->total[1]++;
+
+    if( left && length >= fill )
+    {
+        memcpy( (void *) (ctx->buffer + left),
+                (void *) input, fill );
+        md5_process( ctx, ctx->buffer );
+        length -= fill;
+        input  += fill;
+        left = 0;
+    }
+
+    while( length >= 64 )
+    {
+        md5_process( ctx, input );
+        length -= 64;
+        input  += 64;
+    }
+
+    if( length )
+    {
+        memcpy( (void *) (ctx->buffer + left),
+                (void *) input, length );
+    }
+}
+
+static uchar md5_padding[64] =
+{
+ 0x80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+};
+
+void md5_finish( md5_context *ctx, uchar digest[16] )
+{
+    ulong last, padn;
+    ulong high, low;
+    uchar msglen[8];
+
+    high = ( ctx->total[0] >> 29 )
+         | ( ctx->total[1] <<  3 );
+    low  = ( ctx->total[0] <<  3 );
+
+    PUT_UINT32_LE( low,  msglen, 0 );
+    PUT_UINT32_LE( high, msglen, 4 );
+
+    last = ctx->total[0] & 0x3F;
+    padn = ( last < 56 ) ? ( 56 - last ) : ( 120 - last );
+
+    md5_update( ctx, md5_padding, padn );
+    md5_update( ctx, msglen, 8 );
+
+    PUT_UINT32_LE( ctx->state[0], digest,  0 );
+    PUT_UINT32_LE( ctx->state[1], digest,  4 );
+    PUT_UINT32_LE( ctx->state[2], digest,  8 );
+    PUT_UINT32_LE( ctx->state[3], digest, 12 );
+}
+
+/*
+ * Output MD5(file contents), returns 0 if successful.
+ */
+int md5_file( char *filename, uchar digest[16] )
+{
+    FILE *f;
+    size_t n;
+    md5_context ctx;
+    uchar buf[1024];
+
+    if( ( f = fopen( filename, "rb" ) ) == NULL )
+        return( 1 );
+
+    md5_starts( &ctx );
+
+    while( ( n = fread( buf, 1, sizeof( buf ), f ) ) > 0 )
+        md5_update( &ctx, buf, (uint) n );
+
+    md5_finish( &ctx, digest );
+
+    fclose( f );
+    return( 0 );
+}
+
+/*
+ * Output MD5(buf)
+ */
+void md5_csum( uchar *buf, uint buflen, uchar digest[16] )
+{
+    md5_context ctx;
+
+    md5_starts( &ctx );
+    md5_update( &ctx, buf, buflen );
+    md5_finish( &ctx, digest );
+}
+
+/*
+ * Output HMAC-MD5(key,buf)
+ */
+void md5_hmac( uchar *key, uint keylen, uchar *buf, uint buflen,
+               uchar digest[16] )
+{
+    uint i;
+    md5_context ctx;
+    uchar k_ipad[64];
+    uchar k_opad[64];
+    uchar tmpbuf[16];
+
+    memset( k_ipad, 0x36, 64 );
+    memset( k_opad, 0x5C, 64 );
+
+    for( i = 0; i < keylen; i++ )
+    {
+        if( i >= 64 ) break;
+
+        k_ipad[i] ^= key[i];
+        k_opad[i] ^= key[i];
+    }
+
+    md5_starts( &ctx );
+    md5_update( &ctx, k_ipad, 64 );
+    md5_update( &ctx, buf, buflen );
+    md5_finish( &ctx, tmpbuf );
+
+    md5_starts( &ctx );
+    md5_update( &ctx, k_opad, 64 );
+    md5_update( &ctx, tmpbuf, 16 );
+    md5_finish( &ctx, digest );
+
+    memset( k_ipad, 0, 64 );
+    memset( k_opad, 0, 64 );
+    memset( tmpbuf, 0, 16 );
+    memset( &ctx, 0, sizeof( md5_context ) );
+}
+
+#ifdef SELF_TEST
+/* 
+ * RFC 1321 test vectors
+ */
+static char *md5_test_str[7] =
+{
+    "",
+    "a",
+    "abc",
+    "message digest",
+    "abcdefghijklmnopqrstuvwxyz",
+    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",
+    "12345678901234567890123456789012345678901234567890123456789012" \
+        "345678901234567890"
+};
+
+static uchar md5_test_sum[7][16] =
+{
+    { 0xD4, 0x1D, 0x8C, 0xD9, 0x8F, 0x00, 0xB2, 0x04,
+      0xE9, 0x80, 0x09, 0x98, 0xEC, 0xF8, 0x42, 0x7E },
+    { 0x0C, 0xC1, 0x75, 0xB9, 0xC0, 0xF1, 0xB6, 0xA8,
+      0x31, 0xC3, 0x99, 0xE2, 0x69, 0x77, 0x26, 0x61 },
+    { 0x90, 0x01, 0x50, 0x98, 0x3C, 0xD2, 0x4F, 0xB0,
+      0xD6, 0x96, 0x3F, 0x7D, 0x28, 0xE1, 0x7F, 0x72 },
+    { 0xF9, 0x6B, 0x69, 0x7D, 0x7C, 0xB7, 0x93, 0x8D,
+      0x52, 0x5A, 0x2F, 0x31, 0xAA, 0xF1, 0x61, 0xD0 },
+    { 0xC3, 0xFC, 0xD3, 0xD7, 0x61, 0x92, 0xE4, 0x00,
+      0x7D, 0xFB, 0x49, 0x6C, 0xCA, 0x67, 0xE1, 0x3B },
+    { 0xD1, 0x74, 0xAB, 0x98, 0xD2, 0x77, 0xD9, 0xF5,
+      0xA5, 0x61, 0x1C, 0x2C, 0x9F, 0x41, 0x9D, 0x9F },
+    { 0x57, 0xED, 0xF4, 0xA2, 0x2B, 0xE3, 0xC9, 0x55,
+      0xAC, 0x49, 0xDA, 0x2E, 0x21, 0x07, 0xB6, 0x7A }
+};
+
+/*
+ * Checkup routine
+ */
+int md5_self_test( void )
+{
+    int i;
+    uchar md5sum[16];
+
+    for( i = 0; i < 7; i++ )
+    {
+        printf( "  MD5 test #%d: ", i + 1 );
+
+        md5_csum( (uchar *) md5_test_str[i],
+                    strlen( md5_test_str[i] ), md5sum );
+
+        if( memcmp( md5sum, md5_test_sum[i], 16 ) != 0 )
+        {
+            printf( "failed\n" );
+            return( 1 );
+        }
+
+        printf( "passed\n" );
+    }
+
+    printf( "\n" );
+    return( 0 );
+}
+#else
+int md5_self_test( void )
+{
+    printf( "MD5 self-test not available\n\n" );
+    return( 1 );
+}
+#endif
diff --git a/md5.h b/md5.h
new file mode 100644
index 0000000..cefa7c4
--- /dev/null
+++ b/md5.h
@@ -0,0 +1,57 @@
+#ifndef _MD5_H
+#define _MD5_H
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#ifndef _STD_TYPES
+#define _STD_TYPES
+
+#define uchar   unsigned char
+#define uint    unsigned int
+#define ulong   unsigned long int
+
+#endif
+
+typedef struct
+{
+    ulong total[2];
+    ulong state[4];
+    uchar buffer[64];
+}
+md5_context;
+
+/*
+ * Core MD5 functions
+ */
+void md5_starts( md5_context *ctx );
+void md5_update( md5_context *ctx, uchar *input, uint length );
+void md5_finish( md5_context *ctx, uchar digest[16] );
+
+/*
+ * Output MD5(file contents), returns 0 if successful.
+ */
+int md5_file( char *filename, uchar digest[16] );
+
+/*
+ * Output MD5(buf)
+ */
+void md5_csum( uchar *buf, uint buflen, uchar digest[16] );
+
+/*
+ * Output HMAC-MD5(key,buf)
+ */
+void md5_hmac( uchar *key, uint keylen, uchar *buf, uint buflen,
+               uchar digest[16] );
+
+/*
+ * Checkup routine
+ */
+int md5_self_test( void );
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* md5.h */
